String.format = function() {
    // The string containing the format items (e.g. "{0}")
    // will and always has to be the first argument.
    var theString = arguments[0];
    
    // start with the second argument (i = 1)
    for (var i = 1; i < arguments.length; i++) {
        // "gm" = RegEx options for Global search (more than one instance)
        // and for Multiline search
        var regEx = new RegExp("\\{" + (i - 1) + "\\}", "gm");
        theString = theString.replace(regEx, arguments[i]);
    }
    
    return theString;
}
var isMobile = {
		Android : function() {
			return navigator.userAgent.match(/Android/i);
		},
		BlackBerry : function() {
			return navigator.userAgent.match(/BlackBerry/i);
		},
		iOS : function() {
			return navigator.userAgent.match(/iPhone|iPad|iPod/i);
		},
		Opera : function() {
			return navigator.userAgent.match(/Opera Mini/i);
		},
		Windows : function() {
			return navigator.userAgent.match(/IEMobile/i);
		},
		any : function() {
			return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS()
					|| isMobile.Opera() || isMobile.Windows());
		}
};

function backKeyRegister(callBack){	
	backCallBack=callBack;
	document.addEventListener("backbutton", wrapWithOverlayCheck, false); 
}
var backCallBack=null;

function wrapWithOverlayCheck(){
	
	if(document.overLayInfo){
		document.overLayInfo().close();
	}else{
		backCallBack(); 
	}
}
function exitApp(){
	if(navigator.app){
		navigator.app.exitApp();
	}
}
function onCancel(){		   		
		$("#activate").click();
}

function getItem(key){	
	if (localStorage.getItem(key)) {
		return localStorage.getItem(key);
	} else {
		return null;
	}
}
function setItem(key,val){	
	localStorage.setItem(key,val);
}

function removeItem(key){	
	localStorage.remove(key);
}

function getBootServerIP(cb){	
	 getRemote("http://166.62.38.29/servers.jsp",function(sinfo){			
			var jsonList = sinfo;
			var profile=null;
			$(jsonList.servers).each(function(i,j){
				if(j.profile=="production"){
					profile=j;
				}		
			});	
			cb(profile);
	});
}

function getServer(cb){	
	try{
		if(!isMobile.any() || !mobigentplugin || isMobile.iOS()){
			getBootServerIP(cb);
		}else{	
			mobigentplugin.getServerProfile(function(profile){
				if(profile && profile.ip)
					cb(profile);
				else
					getBootServerIP(cb);				
			}); 
						
		}
		
	}catch(e){
		return "localhost";
	}
}

function getRemote(remote_url,cb) {
    $.get(remote_url,function(sinfo){		
		cb(sinfo);
	});
}

function serverInfo(callBack){
	var serverRoot="http://{0}/buzzoo/micromodel";
	var server = "localhost";
	var port = "8080";
	if (isMobile.any()) { 		
		port =80;
	}   
	getServer(function(profile){		
		var contextRoot = profile.ip;
		if(profile.port){
			port=profile.port;
		}else{
			port=80;
		}
		if(port!=80)
			contextRoot = profile.ip+":"+port;
		window.contextRoot=contextRoot;
		window.server=profile.ip;
		window.serverRoot = String.format(serverRoot,contextRoot);	
		if(callBack)
			callBack(profile);
	});	
}

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function createCount(){
	
}
function checkConnection(callBack) {
    var networkState = navigator.connection.type;
    var states = {};    
    states[Connection.UNKNOWN]  = 'Unknown connection';
    states[Connection.ETHERNET] = 'Ethernet connection';
    states[Connection.WIFI]     = 'WiFi connection';
    states[Connection.CELL_2G]  = 'Cell 2G connection';
    states[Connection.CELL_3G]  = 'Cell 3G connection';
    states[Connection.CELL_4G]  = 'Cell 4G connection';
    states[Connection.CELL]     = 'Cell generic connection';
    states[Connection.NONE]     = 'No network connection';
    callBack(networkState,states[networkState]);
}


function loginMobigent() {
	var object = new Object();
	var filterData = "datadomain = 'Users' and data->>'User Name'='{0}' and data->>'Password'='{1}'";
	filterData = String.format(filterData, $("#username").val(), $("#password")
			.val());
	var object = 'data={"objectClass":"com.jdo.CloudRowData",action="list",limit=1,offset=0,jsonFilter:"'
			+ filterData + '"}';
	execCommand(object, function(data) {
		var respJ = JSON.parse(data);
		if (respJ.rows) {
			respJ = respJ.rows;
		}
		if (respJ.length > 0) {
			if (typeof(cordova) !== 'undefined') {   
				if(!isMobile.any() || !mobigentplugin || isMobile.iOS()){
					onSuccess();
				}else{
					mobigentplugin.startAgent($("#username").val(), function() {
						onSuccess();
					});
				}
			}else{
				
				onSuccess();
			}
		} else {
			onFailure();
		}
	});
}

function execCommand(data, callBack) {
	serverInfo(function() {
		$.ajax({
			type : "POST",
			url : window.serverRoot,
			data : data,
			success : function(data, status) {
				callBack(data);
			},
			async : false
		});
	});

}
