$(document).ready(function() {
	adjustContentView();
	if (!isMobile.any()) {
		onAppReady();
	}
});

var server = "SERVER_URL";
var user = null;
var fromType = "0";
var divertType = "0";


function onAppReady() {
	$(".pushbutton").pushMenu();
	initDatabase();
	readProperty(function(data) {
		user = getItem('userid');
		$("#user").html(user);
		var argA = window.location.href.split("#");
		fromType = argA[1];
		divertType = argA[2];
		var rPhone = user;
		var headerName='Call Divert';
		if (divertType == "2") {
			$("#div_secret").css("display", "block");
			$("#sourceInfo").css("display", "none");
			$("#desc").css("display", "none");
			$("#secret").attr("placeholder", "Reachy Secret of Target Number");

			rPhone = $.trim(argA[3]);
			rPhone = rPhone.replace("hhhh", "/");
			headerName='Cancel Call Divert';
		} else if (divertType == "1") {
			$("#div_secret").css("display", "block");
			rPhone = $.trim(argA[3]);
			rPhone = rPhone.replace("hhhh", "/");
			
			headerName='Remote Call Divert';
		} else {
			$("#div_secret").css("display", "none");
			$("#divertee").attr("readonly", "readonly");
			$("#divertee_look").css("display", "none");
			$("#showLeft1").css("display", "none");
			
		}
		$(".appHeader").append(headerName);
		$("#divertee").val(rPhone);
	});
}

function getSuccessMessage() {

	return "User " + $("#divertee").val() + " diverted to "
			+ $("#target").val() + " successfully";
}
function getFailureMessage() {

	return "Failed to divert user " + $("#divertee").val() + " to target  "
			+ $("#target").val();
}
function onUpdate() {

	if ($("#target").val() == "") {
		toast("Target Address is Required");
		return;
	}
	if ($("#target").val().length < 8) {
		toast("Target Address should be of minimum 8 digits");
		return;
	}
	if (divertType == "2") {
		var pass = $("#secret").val();
		if (pass == "") {
			showAlert("Reachy Secret of " + $("#target").val() + " is required");
			return;
		}
		if (isNaN(parseInt(pass))) {
			showAlert("Invalid Reachy Secret.");
			return;
		}
	}
	if (divertType == "1") {

		if ($("#divertee").val() == "") {
			toast("From Number is Required");
			return;
		}
		var pass = $("#secret").val();
		if (pass == "") {
			showAlert("Reachy Secret of " + $("#divertee").val()
					+ " is required");
			return;
		}
		if (isNaN(parseInt(pass))) {
			showAlert("Invalid Reachy Secret.");
			return;
		}

		if (getNumbersFromString($("#divertee").val()).indexOf(user) != -1) {
			toast("Remote divert is not allowed for the owner.Try local divert");
			return;
		}
	}

	var p = $(".page").progressBlock("Please wait. <br>We are processing..");

	var sm = getSuccessMessage();
	var fm = getFailureMessage();
	var dmm = getDivertModel();

	if (divertType == "2") {
		dmm.action = "delete";
		dmm.object.originAddress = $("#target").val();
		dmm.object.divertAddress = $("#target").val();

		sm = "User " + $("#target").val() + " is back on his phone";
		fm = "Failed to clear the divert of user " + $("#target").val() + " ";
	}	
	mobigentplugin.createTask( [ dmm, server, "data", "imageName",
	                 			[ sm, fm ] ],function(result){
		p.dispose();
		toast("Updated information Successfully");
		
		//$("#update").popup('close');
		setTimeout(function(){			
			goBack();
		},1500);
		
	},
	function(err){
		showAlert(err);
	});	

}

function getDivertModel() {
	var dm = new Object();
	dm.actionUser = user;
	dm.originAddress = $("#divertee").val();
	dm.divertAddress = $("#target").val();
	dm.secret = $("#secret").val();
	dm.divertReason = $("#divertReason").val();

	var dmMeta = new Object();
	dmMeta.objectClass = "com.jdo.CloudDivert";
	dmMeta.object = dm;
	dmMeta.action = "add_or_edit";
	return dmMeta;
}
function goBack() {
	var goL = "list.html";
	if (fromType == "1") {
		goL = "demo.html";
	}
	window.open(goL, "_self");
}
var outPattern = null;
function showContacts(pat) {
	outPattern = pat;
	if (!contacts) {
		fetchContacts();
	}
	$("#contactspanel").click();
}

function fetchContacts() {

	if (!isMobile.any()) {
		var myContactsA = new Array();
		myContactsA.push({
			"name" : "Dhan",
			"phone" : "9881763210",
			"photo" : "../arr.png"
		});
		myContactsA.push({
			"name" : "Amma",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Achan",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "9881763210",
			"photo" : "../user.png"
		});
		
		renderContacts(myContactsA);

	} else {

		readRecords("contacts", "", function(data) {
			if (!data || data.length == 0) {
				console.log("Reading contacts from Mobile");
				syncContacts(function(myContactsA) {
					renderContacts(myContactsA);
				});
			} else {
				//showAlert("LocalData","Local","Done");
				renderContacts(data);
			}

		});

	}
}
var offset = 0;
var fc = 50;
var contacts = null;
var dMap = [];
$("#stext").keyup(function() {
	$("#contacts .row").unbind();
	$("#contacts .row").remove();
	processData(dMap, $("#stext").val());
});

function renderContacts(contacts1) {

	//$("#contacts li").remove();
	//$("#contacts li").unbind();
	contacts = contacts1.sort(sortNames);

	if (isMobile.any()) {
		mobigentplugin.fetchDiverts(function(result) {

			$.each(result, function(i, j) {
				dMap[j.number] = j;
			});
			processData(dMap);
		}, function(err) {
			showAlert(err);
		});
	} else {

		processData(dMap);
	}

	//register();

}
function processData(dMap, match) {

	var cs = contacts.length;
	var dataS = "";
	var mc = 0;
	for (i = offset; i < cs + offset; i++) {
		//	for (i = 0; i < 10; i++) {
		var record = contacts[i];
		var ha = '</h2>';
		var ppp = getNumbersFromString(record.phone);
		var len = Math.min(10, ppp);
		var ph = ppp.substring(ppp.length - len, ppp.length);
		if (match) {
			var f = false;
			if (record.phone.toLowerCase().indexOf(match) != -1) {
				f = true;
			} else if (record.name.toLowerCase().indexOf(match) != -1) {
				f = true;
			}
			if (!f) {
				continue;
			}
		}

		if (dMap[ph]) {
			ha = '<img class="pin" src="images/reachy/r_arr_1.png"/></h2>';
		}
		dataS += '<li id="rownum_'+i+'" class="row">'
			+'<div class="agree"><input onclick="onSelectItem(this)" class="agreeCheck" id="agree_'+i+'" type="checkbox"><label	for="agree_'+i+'"></label></div>'
				+ '<div style="float:left"><h2 class="small name textData">'
				+ record.name
				+ ha
				+ '<p class="small smalltext phone textData">'
				+ record.phone
				+ '</p></div>'
				//+'</a> <a onclick="openConfigure(this);" class="cdn">Divert Call</a></li>';
				//+ '<img class="callbutton"  style="float:right;position:absolute;margin-top:5px;right:2px;height:50px;border-radius:30px;border:1px solid #fff" src="check.png"/>';
		+'</li>';
		mc++;
		
		if (mc >= 20) {
		break;
		}
		
		
	}
	$("#contacts").append(dataS);
	
//	$("#contacts .callbutton").click(function() {
//		$(outPattern).val($(".phone", $(this).parent()).html());
//		$("#rightpanel1").panel('close');
//	});
	
	$("#contacts .searchtext").unbind();
	$("#contacts .searchtext").keydown(function(){
		setTimeout(function(){
			var obj = $("#contacts li.row");
			var val = $("#contacts .searchtext").val().toLowerCase();
			$("#contacts li.row").remove();
			processData(dMap, val);
			/*$(obj).each(function(i,j){			
				if($(".textData",j).html().toLowerCase().indexOf(val)!=-1){
					$(j).css("display","block");
				}else{
					$(j).css("display","none");
				}
			});*/
		},100);
		
	});
	
}
function sortNames(a, b) {
	return a.name.toLowerCase() > b.name.toLowerCase() ? 1 : -1;
}

var parent=null;

function onSelectItem(obj){
	if(obj.checked){
		setTimeout(function(){
			parent.onSelected(parent,$("#rownum_"+obj.id.split("_")[1]+" .phone").html());
		},100);		
	}	
}
function loadContacts(obj){
	parent=obj;
	$("#contacts .row").remove();
	fetchContacts();
}